/*============================================================================
                           QUEUE CLASS  (with garbage collection)
File name:"queue_module.cpp". Do not modify it: it is used by other programs.
The class queue is: class queue {public : cell* first; cell* last;};
------------------------------------------------------------------------------
The elements of the queue have type QueueValues.
The type QueueValues has to be instantiated via, for instance:
        typedef int QueueValues;     <--- before: #include "queue_module.cpp"
for having a queue of type int. This queue_module can be used by writing:
        #include "queue_module.cpp"  <--- after:  typedef int Values
Elements are coming to the queue from the right and exiting from the left:
Given the queue         q:   <= 3 2 2 5 1 <=
outqueue(n,q) produces  q:   <= 2 2 5 1 <=   and n=3
=========================================================================== */
#include  <iostream.h> 
//----------------------------------------------------------------------------
class cell
{public :
   QueueValues atom; cell* next;
   cell(QueueValues at, cell* nx) : atom(at), next(nx) { };};
class queue
{public : cell* first; cell* last;};
//----------------------------------------------------------------------------
//                    making an empty queue
void emptyqueue(queue &q) {q.first=NULL; q.last=NULL;}
//----------------------------------------------------------------------------
//                    testing whether or not a queue is empty
bool isemptyqueue(queue q) {return  ((q.first == NULL) && (q.last == NULL));}
//----------------------------------------------------------------------------
//                    inserting in a queue
void inqueue(QueueValues n, queue &q)
{cell* newelem=new cell(n,NULL);
 {if (isemptyqueue(q)) {q.first=newelem;}
             else {q.last->next=newelem;};
  q.last=newelem;};}
//----------------------------------------------------------------------------
//                    extracting from a queue
void outqueue(QueueValues &n, queue &q)
{if (q.first == NULL) {cout << "Error: out from empty queue!";}
     else {cell* disp_ptr=q.first; // for garbage collection
           n=q.first->atom;
           if (q.first->next!=NULL) {q.first=q.first->next;}
           else {q.last=NULL; q.first=NULL;};
           delete disp_ptr;};}     // garbage collection
//----------------------------------------------------------------------------